自定义博客皮肤VIP专享

*博客头图:

格式为PNG、JPG,宽度*高度大于1920*100像素,不超过2MB,主视觉建议放在右侧,请参照线上博客头图

请上传大于1920*100像素的图片!

博客底图:

图片格式为PNG、JPG,不超过1MB,可上下左右平铺至整个背景

栏目图:

图片格式为PNG、JPG,图片宽度*高度为300*38像素,不超过0.5MB

主标题颜色:

RGB颜色,例如:#AFAFAF

Hover:

RGB颜色,例如:#AFAFAF

副标题颜色:

RGB颜色,例如:#AFAFAF

自定义博客皮肤

-+
  • 博客(10)
  • 收藏
  • 关注

原创 ICPC 2025 西安 (部分)

则可以用这个条件去淘汰图上的边,得到的树即是答案。,建图,答案是这个图的一个生成树。考虑怎么排除图上的边:若。对于判断条件1,3很好计算,对于条件2,线性dp就行了。正解是找lca,但vp的时候没想到,用了一个理论复杂度。这样只是找边的时候约束更强,极限复杂度还是。很大,但还能小小优化(卡常)。或存在两个连续的1,且序列不全为1,则序列合法。若序列中存在一个数大于1小于n,则序列合法。是偶数,序列全为1,序列合法。直接相连的必要条件,据此。的,但是交上去居然过了。是树边,则对于任意的点。

2025-10-27 21:12:22 472

原创 codeforces 补题记录3 (Round 1020 div3, Round 1028 div1, Round 1032 div3)

不难发现,0把平面分成分成上下两部分,1在这个纵向序列中只有一个0,这个0和左边的0产生的下方的0相连,和右边的0产生的上方0相连。不难发现,最小值是传递的,那么下标为7的数(这三次操作后)就是下标为1,2,4,5的数(这三次操作前)的最小值,这个下标为7的数操作后的数是已知的。考虑一个位置的数,如果我们它的值在过程中被修改了,也就是某一步操作的z是它,怎么求它原来的值呢?这道题我用线性dp写的,但是有点麻烦,看了题解才发现题解更简单,并且题解这个思路可能对其他题有启发,这里简单说一下。

2025-06-27 00:59:24 523

原创 codeforces 补题记录2(Round 1019 div3, Round 1027 div3, Round 1029 div3)

(原题 https://codeforces.com/gym/104857/problem/J)枚举边,假设它是最长边,起点到它的路径最长边和它到终点的路径最长边作为次长边的候选,显然选较长的那个。那么这道题简直如出一辙,区别是这里枚举边我们假设它是最短边,起点到它的路径最长边和它到终点的路径最长边作为最长边的候选。f[a]表示a分成数的个数的最小值,b是a的因数,a/b≤k,则f[a]可以由f[b]转移过来,即。x和y都是1e6数量级,dp的转移都在因数内,因数个数上界是1/3次方,这样估计是能过的。

2025-06-25 21:33:45 710

原创 暑假到了,做cf找点题感

aof lengthn∗1≤i≤n−3ai​ai2​ai1​ai3​aai​ai1​ai2​ai3​ai2​ai3​ai​ai1​†∗nn1ton231541222134n34†An arrayxyxyxy你得到一个长度为n∗的排列a。您可以执行以下操作任意次数(可能为零):—选择索引1≤i≤n−3。然后,将ai​与ai2​。

2025-06-23 22:54:31 926

原创 1111 双十一就应该做题

T1 xj中学的诈骗犯 题面 n个数,两个人轮流选操作。每一次操作选择一个最大的数分裂。分裂一个数x就是选择一个小于x的非负整数y。若y=0则这个数消失,否则,对于y的每个因子,有z/y的概率生成一个数z。若某回合开始时没有数了,则这回合操作的人失败。问先手获胜的概率。(ai<=100,n<=100,精确到1e-9,SPJ). 思路 这是一道 诈骗题 啊啊啊啊啊啊啊啊 考虑最大值个数的奇偶性。最终状态:最大值个数(1个)是奇数。 若最大值个数是偶数,操作后一定使最大值个数为奇数。

2021-11-17 14:50:10 152

原创 ¿¿¿NOIP 模拟赛(用于增强信心)

##### $T1$ 困难的概率题 ###### 题面 小可可现在有 n 个分身,每个分身有 ai 个奖杯。现在会按照从 1 到 n 的顺序,每个分身会将自己有的所有奖杯一个一个地随机地分给其它 n −1 个分身。问最后每个分身期望有的奖杯的个数,对998244353 取模。 ###### 思路 期望=概率*权值。1~n向右算一遍增加的奖杯数的期望,记录向左增加的奖杯数的期望。n~1扫一遍求前缀和。$O(n)$ ##### $T2$ 组合数学好 ###### 题面 这天sb又要写n个字符串,只

2021-11-17 14:44:47 463

原创 11.5又是三道水题

水题(指三道题debug了接近一天),T4摆烂了 T1初中数学题 大意 ∏(ai^2+bi^2)=x^2+y^2,输入正整数ai,bi,输出正整数x,y 思路 直接把答案算出来后暴力枚举肯定是不行的,所以ai和bi能对我们的答案有提示。尝试思考数学方法。当n=2时如何求解。化简 $$ 原式=a1^2a2^2+a1^2b2^2+b1^2a2^2+b1^2b2^2 =(a1a2+b1b2)^2+(a1b2-b1a2)^2 $$ 这样(a1^2+b1^2)(a2^2+b2^2)=x^2+y^2

2021-11-08 20:28:41 246 1

原创 1108题解

T1 签到题,这回是真的 题面 给定一张 m 条边,n 个顶点组成的无向图 G ,顶点从 1 到 n 依次标号,保证 G 中 任意两点均可互相到达。现需要给 G 中尽量多的边指定方向,构成一张新的混合图 G′,使得 G′ 中任意两点 仍均可达。 思路 复习(copy)Tarjan。 桥不能有方向,其他边都有方向。方向就是搜索的方向。 T2 hard problem with water data 题面 给定n个正整数ai,选若干个数,保证这些数两两互质,求选择数的数量的最大值。 (n,ai

2021-11-08 20:25:28 356 1

原创 2021-10-15

intervals 题目描述 给定 n 个闭区间 [ai,bi]和 n 个整数 ci 。你需要构造一个整数集合 Z,使得对于任意 i∈[1,n],Z 中满足 ai≤x≤bi的整数 x 不少于 ci个,求这样的整数集合 Z 最少包含多少个数。 简而言之就是,从 0∼5×104中选出尽量少的整数,使每个区间 [ai,bi]内都有至少 ci个数被选出。 解题思路 一、贪心 1. 按右端点排序。 2. 枚举每个区间,(a[i].c-区间已被选的个数)就是需要在该区间选择的数的个数,优先从右侧开始选择。

2021-10-15 10:32:04 255

原创 9.8的水题

9.8 医院设置 深搜,一个点只搜一次,O(n^2). 黑暗城堡 首先,DJ求出所有点的单元最短路,以及通往点 i 的边能作为该点的最短路的个数,记为 wyy[i]。 然后乘法原理!!!! wyy[i]的累积就是答案。 如图 答案ans=1*1*3*3,因为每个点 i 都有wyy[i]种选法使1到它的路径最短。 清闲的都市 最小生成树模板。 泼水节 回顾kurskal的方法,把图上的边放进优先队列,每次提出最短边,若两端点属于同...

2021-09-09 20:56:24 152 1

空空如也

空空如也

TA创建的收藏夹 TA关注的收藏夹

TA关注的人

提示
确定要删除当前文章?
取消 删除